import { Invoke } from "./Invoke";
import { Promisify } from "./Promisify";
export declare abstract class CommunicatorBase<Listener extends object = {}> {
    /**
     * @hidden
     */
    protected listener_: Listener;
    /**
     * @hidden
     */
    private static SEQUENCE;
    /**
     * @hidden
     */
    private promises_;
    constructor(listener?: Listener);
    destroy(): Promise<void>;
    getDriver<Feature extends object>(): Promisify<Feature>;
    /**
     * @hidden
     */
    private _Proxy_func;
    /**
     * @hidden
     */
    private _Call_function;
    abstract sendData(invoke: Invoke): void;
    replyData(invoke: Invoke): void;
    /**
     * @hidden
     */
    private _Handle_function;
    /**
     * @hidden
     */
    private _Handle_return;
    /**
     * @hidden
     */
    private _Send_return;
}
