"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var HashMap_1 = require("tstl/container/HashMap");
var Pair_1 = require("tstl/utility/Pair");
var LogicError_1 = require("tstl/exception/LogicError");
var CommunicatorBase = /** @class */ (function () {
    /* ----------------------------------------------------------------
        CONSTRUCTORS
    ---------------------------------------------------------------- */
    function CommunicatorBase(listener) {
        if (listener === void 0) { listener = null; }
        this.listener_ = listener;
        this.promises_ = new HashMap_1.HashMap();
    }
    CommunicatorBase.prototype.destroy = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_1, _a, _b, _c, entry, reject;
            return __generator(this, function (_d) {
                try {
                    for (_b = __values(this.promises_), _c = _b.next(); !_c.done; _c = _b.next()) {
                        entry = _c.value;
                        reject = entry.second.second;
                        reject();
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                this.promises_.clear();
                return [2 /*return*/];
            });
        });
    };
    /* ----------------------------------------------------------------
        DRIVER
    ---------------------------------------------------------------- */
    CommunicatorBase.prototype.getDriver = function () {
        var _this = this;
        return new Proxy({}, {
            get: function (target, name) {
                target;
                return _this._Proxy_func(name);
            }
        });
    };
    /**
     * @hidden
     */
    CommunicatorBase.prototype._Proxy_func = function (name) {
        var _this = this;
        return new Proxy(function () {
            var params = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                params[_i] = arguments[_i];
            }
            return _this._Call_function.apply(_this, __spread([name], params));
        }, {
            get: function (target, newName) {
                target;
                return _this._Proxy_func(name + "." + newName);
            }
        });
    };
    /**
     * @hidden
     */
    CommunicatorBase.prototype._Call_function = function (name) {
        var _this = this;
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        return new Promise(function (resolve, reject) {
            // CONSTRUCT INVOKE MESSAGE
            var invoke = {
                uid: ++CommunicatorBase.SEQUENCE,
                name: name,
                params: params
            };
            // DO SEND WITH PROMISE
            _this.promises_.emplace(invoke.uid, Pair_1.make_pair(resolve, reject));
            _this.sendData(invoke);
        });
    };
    CommunicatorBase.prototype.replyData = function (invoke) {
        if (invoke.name)
            this._Handle_function(invoke);
        else
            this._Handle_return(invoke);
    };
    /**
     * @hidden
     */
    CommunicatorBase.prototype._Handle_function = function (invoke) {
        var e_2, _a;
        var uid = invoke.uid;
        try {
            //----
            // FIND FUNCTION
            //----
            if (this.listener_ === null) // LISTENER MUST BE
                throw new LogicError_1.InvalidArgument("Listener is not specified yet.");
            // FIND FUNCTION (WITH THIS-ARG)
            var func = this.listener_;
            var thisArg = null;
            var routes = invoke.name.split(".");
            try {
                for (var routes_1 = __values(routes), routes_1_1 = routes_1.next(); !routes_1_1.done; routes_1_1 = routes_1.next()) {
                    var name_1 = routes_1_1.value;
                    thisArg = func;
                    func = thisArg[name_1];
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (routes_1_1 && !routes_1_1.done && (_a = routes_1.return)) _a.call(routes_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            //----
            // RETURN VALUE
            //----
            // CALL FUNCTION
            var ret = func.apply(thisArg, invoke.params);
            // PROMISE | ATOMIC
            if (ret && ret.then instanceof Function) // Async
                ret.then(this._Send_return.bind(this, uid, true))
                    .catch(this._Send_return.bind(this, uid, false));
            else
                this._Send_return(uid, true, ret); // Sync
        }
        catch (exp) {
            this._Send_return(uid, false, exp);
        }
    };
    /**
     * @hidden
     */
    CommunicatorBase.prototype._Handle_return = function (invoke) {
        // GET THE PROMISE OBJECT
        var it = this.promises_.find(invoke.uid);
        if (it.equals(this.promises_.end()))
            return;
        // RETURNS
        var func = invoke.success
            ? it.second.first
            : it.second.second;
        this.promises_.erase(it);
        func(invoke.value);
    };
    /**
     * @hidden
     */
    CommunicatorBase.prototype._Send_return = function (uid, flag, val) {
        var ret = { uid: uid, success: flag, value: val };
        this.sendData(ret);
    };
    /**
     * @hidden
     */
    CommunicatorBase.SEQUENCE = 0;
    return CommunicatorBase;
}());
exports.CommunicatorBase = CommunicatorBase;
//# sourceMappingURL=CommunicatorBase.js.map