"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var CommunicatorBase_1 = require("../CommunicatorBase");
var WebAcceptor = /** @class */ (function (_super) {
    __extends(WebAcceptor, _super);
    /* ----------------------------------------------------------------
        CONSTRUCTORS
    ---------------------------------------------------------------- */
    function WebAcceptor(server, request) {
        var _this = _super.call(this) || this;
        _this.server_ = server;
        _this.request_ = request;
        return _this;
    }
    WebAcceptor.prototype.accept = function (protocol, allowOrigin, cookies) {
        this.connection_ = this.request_.accept(protocol, allowOrigin, cookies);
        this.connection_.on("close", this._Handle_close.bind(this));
        this.connection_.on("error", this._Handle_error.bind(this));
    };
    WebAcceptor.prototype.listen = function (listener) {
        this.listener_ = listener;
        this.connection_.on("message", this._Handle_message.bind(this));
    };
    /* ----------------------------------------------------------------
        ACCESSORS
    ---------------------------------------------------------------- */
    WebAcceptor.prototype.getServer = function () {
        return this.server_;
    };
    WebAcceptor.prototype.getPath = function () {
        return this.request_.resource;
    };
    /* ----------------------------------------------------------------
        MESSAG I/O
    ---------------------------------------------------------------- */
    WebAcceptor.prototype.sendData = function (invoke) {
        this.connection_.sendUTF(JSON.stringify(invoke));
    };
    WebAcceptor.prototype._Handle_message = function (message) {
        var invoke = JSON.parse(message.utf8Data);
        this.replyData(invoke);
    };
    WebAcceptor.prototype._Handle_close = function (code, reason) {
        console.log(code, reason);
    };
    WebAcceptor.prototype._Handle_error = function (error) {
        console.log(error);
    };
    return WebAcceptor;
}(CommunicatorBase_1.CommunicatorBase));
exports.WebAcceptor = WebAcceptor;
//# sourceMappingURL=WebAcceptor.js.map