"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
require("websocket-polyfill");
var CommunicatorBase_1 = require("../CommunicatorBase");
var WebConnector = /** @class */ (function (_super) {
    __extends(WebConnector, _super);
    /* ----------------------------------------------------------------
        CONSTRUCTOR
    ---------------------------------------------------------------- */
    function WebConnector(listener) {
        if (listener === void 0) { listener = null; }
        return _super.call(this, listener) || this;
    }
    /* ----------------------------------------------------------------
        SOCKET
    ---------------------------------------------------------------- */
    WebConnector.prototype.connect = function (url, protocols) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.socket_ = new WebSocket(url, protocols);
            _this.socket_.onopen = resolve;
            _this.socket_.onerror = reject;
            _this.socket_.onclose = _this.destroy.bind(_this);
            _this.socket_.onmessage = function (msg) {
                _this.replyData(JSON.parse(msg.data));
            };
        });
    };
    WebConnector.prototype.close = function (code, reason) {
        this.socket_.close(code, reason);
    };
    /* ----------------------------------------------------------------
        COMMUNICATOR
    ---------------------------------------------------------------- */
    WebConnector.prototype.sendData = function (invoke) {
        this.socket_.send(JSON.stringify(invoke));
    };
    return WebConnector;
}(CommunicatorBase_1.CommunicatorBase));
exports.WebConnector = WebConnector;
//# sourceMappingURL=WebConnector.js.map