"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var http = require("http");
var ws = require("websocket");
var WebAcceptor_1 = require("./WebAcceptor");
var WebServer = /** @class */ (function () {
    function WebServer() {
        /**
         * @hidden
         */
        this.server_ = null;
    }
    WebServer.prototype.open = function (port, cb) {
        var _this = this;
        // HTTP SERVER
        this.server_ = http.createServer();
        this.server_.listen(port);
        // PROTOCOL - ACCEPTOR
        var wServer = new ws.server({ httpServer: this.server_ });
        wServer.on("request", function (request) {
            var acceptor = new WebAcceptor_1.WebAcceptor(_this, request);
            cb(acceptor);
        });
    };
    WebServer.prototype.close = function () {
        if (this.server_)
            this.server_.close();
    };
    return WebServer;
}());
exports.WebServer = WebServer;
//# sourceMappingURL=WebServer.js.map