"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var std = require("tstl");
var web_1 = require("../../protocol/web");
var Calculator_1 = require("../base/Calculator");
var ICalculator_1 = require("../base/ICalculator");
var IVector_1 = require("../base/IVector");
var PORT = 10919;
function test_web() {
    return __awaiter(this, void 0, void 0, function () {
        var e_1, _a, server, _b, _c, path, connector, driver, e_1_1;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    server = new web_1.WebServer();
                    server.open(PORT, function (acceptor) {
                        acceptor.accept(); // ALLOW CONNECTION
                        acceptor.listen(/calculator/.test(acceptor.getPath())
                            ? new Calculator_1.Calculator()
                            : new std.Vector()); // SET LISTENER
                    });
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 10, 11, 12]);
                    _b = __values(["calculator", "vector"]), _c = _b.next();
                    _d.label = 2;
                case 2:
                    if (!!_c.done) return [3 /*break*/, 9];
                    path = _c.value;
                    connector = new web_1.WebConnector();
                    return [4 /*yield*/, connector.connect("ws://127.0.0.1:" + PORT + "/" + path)];
                case 3:
                    _d.sent();
                    driver = connector.getDriver();
                    if (!(path === "calculator")) return [3 /*break*/, 5];
                    return [4 /*yield*/, ICalculator_1.ICalculator.main(driver)];
                case 4:
                    _d.sent();
                    return [3 /*break*/, 7];
                case 5: return [4 /*yield*/, IVector_1.IVector.main(driver)];
                case 6:
                    _d.sent();
                    _d.label = 7;
                case 7:
                    connector.close();
                    _d.label = 8;
                case 8:
                    _c = _b.next();
                    return [3 /*break*/, 2];
                case 9: return [3 /*break*/, 12];
                case 10:
                    e_1_1 = _d.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 12];
                case 11:
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 12:
                    // CLOSE SERVER TOO
                    server.close();
                    return [2 /*return*/];
            }
        });
    });
}
exports.test_web = test_web;
//# sourceMappingURL=web.js.map